# 하늘의 궤적 the 1st 1.0.3
# BID: 4FC3CB13E1D3292E

DECLARATIONS:
  # Lock Max Handheld Resolution to 720p instead of 900p
  -
    type: code
    name: adjustDrResToNativeInHH
    instructions: [
      [cmp, w9, 1280],
      [b.le, :goto1],
      [adrp, x21, 0x65D000],
      [ldr, w21, [x21, 0x830]], ## REF: nn::oe::GetOperationMode in nnMain
      [cbnz, w21, :goto1],
      [mov, w9, 1280],
      [mov, w8, 720],
      :goto1, [stp, w9, w8, [x19, 0x10]],
      [ret]
    ]
MASTER_WRITE:
  ## REF: 69 22 02 29
  -
    type: asm_a64
    main_offset: 0x236744
    instructions: [
      [bl, _adjustDrResToNativeInHH()]
    ]
ALL_FPS:
  # Min Delta
  ## REF: 88 01 80 52 C1 03 80 52 28 4D 28 9B 29 00 80 52, first ADRP + ADD below it
  -
    type: evaluate_write
    address: [MAIN, 0x65D860, 0x2C]
    value_type: uint32
    value: FPS_TARGET
  # Dynamic Resolution and Min Delta multiplier (some UI elements are not adjusted by it, that's why I'm using both values)
  ## REF: First function in .init_array section, ADRP + ADD + 0x220 (default float: 2)
  ## Adding there 0.95 by myself because game seems to have issues with reaching 60 FPS with 1.0
  -
    type: write
    address: [MAIN, 0x65D378]
    value_type: float
    value: 0.95
